// Made by Willy, licensed under the Creative Commons - GNU 
// GPL license. 
// Rostock
dl = 0.0; // Lagerverschiebung wg. Warping ???
iu = 2/sqrt(3); // Faktor für $fn=6 cylinder damit Bohrung passt
pm = 0.22; // plus-minus, damit Brücken höhenverschoben

module lager(ll) {
 difference() {
  cube([20-ll, 4.2, 10], center=true);
  translate([0, -1.81, 0]) rotate([90, 0, 0]) 
   cylinder(r1=2.5, r2=4.8, h=0.62, center=true, $fn=12);
  translate([0, 1.81, 0]) rotate([-90, 0, 0]) 
   cylinder(r1=2.5, r2=4.8, h=0.62, center=true, $fn=12);
 }
}

module loch60(ll, rr) { // Reprap-Loch mit 60°
 cylinder(h = ll, r = iu*rr, $fn=6, center = true);
// cylinder(h = ll, r = rr, $fn=24, center = true);
// difference() { 
//  translate(v = [0, rr, 0]) { // 60° Wände
//   rotate(a=90, v=[0,0,1]) {
//    cylinder(h = ll, r = rr, $fn=3, center = true);
//   }
//  }
//  rotate(a= 0, v=[0,0,1]) { // Welle - 60° Deckel
//   translate(v = [0, 1.5*rr, 0]) { 
//     cube([1.5*rr, rr, ll], center = true);
//   }
//  }
// }
}

difference() {
 union() {
  translate([30, -1.75, 34]) cube([14.4, 26.5, 68], center=true);
  difference() {
   union() {
    translate([-31.75, 0, 17.5]) cube([26.5, 14.4, 35], center=true);
    translate([-42.5, 0, 34]) rotate([0, 90, 0]) 
     cylinder(r=9, h=5, center=true, $fn=8);
   }
   // abschrägen:
   translate([-70, 0, 16.8-pm]){ // aussen
    rotate([0, 0, 45]) {
     cylinder(r1=45, r2=34.9, h=34, center=true, $fn=4);
    }
   }
   translate([8, 0, 22]){ // innen
    rotate([0, 0, 45]) {
     cylinder(r1=35, r2=48, h=34, center=true, $fn=4);
    }
   }
  }
  translate([-37.8, 0, 51]) cube([14.4, 14.4, 34], center=true);
  difference() {
   translate([-27.85, 3.7239, 51]) rotate([0, 0, 60])
    cube([14.4, 14.4, 34], center=true);
   translate([-27.85, 20, 51]) rotate([-14,0,0])
    cube([14.6, 14.6, 40], center=true);
   translate([-11.1, 0, 51]) rotate([0, 10, 0])
    cube([14.6, 14.6, 40], center=true);
  }
  difference() {
   translate([-27.85,-3.7239, 50]) rotate([0, 0, -60])
    cube([14.4, 14.4, 36], center=true);
   translate([-20.85, -16, 52]) rotate([0,0,30]) rotate([16,0,0])
    cube([14.8, 14.6, 50], center=true);
  }
  translate([-1.75, 5.75, 30.3]) cube([49.5,  5.5, 60.6], center=true);
  translate([-30, 0, 34]) rotate([0, 0, 15]) 
   cylinder(r=9.2, h=68, center=true, $fn=12);
  translate([ 30, 0, 34]) rotate([0, 0, 22.5]) 
   cylinder(r=9.2, h=68, center=true, $fn=8);
  translate([30.0,-12.5, 34]) rotate([90, 0, 0]) 
   cylinder(r=9, h=5, center=true, $fn=8);
  //Riemen:
  translate([-3, -2.75, 12]) cube([5,  12.5, 24], center=true);
  translate([-9.6, -2.75, 12]) cube([5,  12.5, 24], center=true);
  for(i = [0:5]) {
   translate([-4.0-0.1, -2.5, i*4+2]) rotate([90, 0, 0]) 
    cylinder(r=2, h=12.9, center=true, $fn=6);
  }
  // parallel joints:
  translate([-44.25, 20.9393+2.06,5.2]) rotate([0, 90, 0]) rotate([0,0,30])
    cylinder(r=iu*5.2, h=6.5, center=true, $fn=6);
  translate([-44.25, 17.4393,10]) cube([6.5, 9.1213, 20], center=true);
  translate([ 44.25, 20.9393+2.06,5.2]) rotate([0, 90, 0]) rotate([0,0,30])
    cylinder(r=iu*5.2, h=6.5, center=true, $fn=6);
  translate([ 44.25, 17.4393,10]) cube([6.5, 9.1213, 20], center=true);
  translate([-38.409, 9.091, 10]) rotate([0, 0, 45])
   cube([7.5, 18.2132, 20], center=true);
  translate([ 38.409, 9.091, 10]) rotate([0, 0,-45])
   cube([7.5, 18.2132, 20], center=true);
  // Gegen Warping:
  translate([18, 3, 4.5])
   cube([10, 8, 9], center=true);
  translate([17.25, 3, 30]) scale([0.25, 1, 1]) {
   rotate([90, 0, 0]) {  
    rotate([0, 0, 60]) {
     cylinder(r=34.5, h=8, center=true, $fn=3);
    }
   }
  }
 } // union
 // parallel joints:
  translate([0, 22, 13+10.4]) rotate([0, 90, 0]) 
   cylinder(r=13, h=120, center=true, $fn=14);
  translate([0, 22, 13+10.4+5.8]) rotate([0, 90, 0]) 
   cylinder(r=13, h=120, center=true, $fn=14);
 
  translate([0, 22, 5.2]) scale([1, 0.98, 1]) rotate([0, 90, 0]) 
   rotate([0, 0, 30]) cylinder(r=iu*3.6, h=88.2, center=true, $fn=6);
  translate([0, 22, 5.2]) scale([1, 0.98, 1]) rotate([0, 90, 0]) 
   rotate([0, 0, 30]) cylinder(r=iu*2.9, h=98, center=true, $fn=6);

 // Mutter-Öffnung (Skeinforge-Hilfe):
// translate([20.8, 12-dl, 4.5+pm+0.2]) cube([4,  12.3, 6.12], center=true);
 // Bohrung Führungsstangen:
 translate([ 30, 0, 34]) rotate([0, 0, 22.5]) 
  cylinder(r=5.412, h=70, center=true, $fn=8);
 translate([-30, 0, 34]) rotate([0, 0, 30]) 
  cylinder(r=5.412, h=70, center=true, $fn=6);
 // Schrauben M3x16:
 translate([-37.0, 0,  34-pm]) rotate([90, 0, 0]) loch60(18, 1.6);
 translate([-39.8, 0,  34-pm]) rotate([90, 0, 0]) loch60(18, 1.6);
 translate([-38.4, 0,  34-pm]) rotate([-90, 0, 0]) loch60(18, 1.6);
 translate([-37.0, -11.2,  34-pm]) rotate([90, 0, 0]) // Kopf
  cylinder(r=3.3, h=8, center=true, $fn=20);
 translate([-38.0, -11.2,  34-pm]) rotate([90, 0, 0]) // Kopf
  cylinder(r=3.65, h=8, center=true, $fn=6);
 translate([-22.5, 0, 4.5-pm]) rotate([90, 0, 0]) loch60(18, 1.6);
 translate([-22.5, -11.2,  4.5-pm]) rotate([90, 0, 0]) // Kopf
  cylinder(r=3.3, h=8, center=true, $fn=20);
 // 60° Lager
 translate([-26.25, 6.4952, 63.5-pm]) rotate([90, 0, 60]) 
  loch60(18, 1.6);
 translate([-26.25, 6.4952, 63.5-pm]) rotate([90, 0, 60]) // Kopf
  translate([0,0,-11.2]) cylinder(r=4.3, h=8, center=true, $fn=20);
 translate([-26.25,-6.4952, 59.5-pm]) rotate([90, 0,-60]) 
  loch60(18, 1.6);
 translate([-26.25,-6.4952, 59.5-pm]) rotate([90, 0,-60]) // Kopf
  translate([0,0,11.2]) cylinder(r=3.3, h=8, center=true, $fn=20);
 //
 translate([30,-9.8,  34+pm]) rotate([90, 0, 90]) loch60(18, 1.6);
 translate([30,-7.0,  34+pm]) rotate([90, 0, 90]) loch60(18, 1.6);
 translate([30,-8.4,  34+pm]) rotate([-90, 0, 90]) loch60(18, 1.6);
 translate([41.2,-7.0,  34+pm]) rotate([90, 0, 90]) // Kopf
  cylinder(r=3.3, h=8, center=true, $fn=20);
 translate([41.2,-8.0,  34+pm]) rotate([90, 0, 90]) // Kopf
  cylinder(r=3.65, h=8, center=true, $fn=6);
 translate([30, 7.5-dl, 4.5+pm]) rotate([90, 0, 90]) loch60(18, 1.6);
 translate([30, 7.5,63.5+pm]) rotate([90, 0, 90]) loch60(18, 1.6);
 translate([41.2, 7.5, 63.5+pm]) rotate([90, 0, 90]) // Kopf
  cylinder(r=3.3, h=8, center=true, $fn=20);
 translate([43.2, 7.5-dl,4.5+pm]) rotate([90, 0, 90]) loch60(12, 3.63);
 // Muttern:
 translate([-37.0, 10.15+0.4,  34-pm]) rotate([90, 0, 0]) 
  cylinder(r=3.3, h=8, center=true, $fn=6);
 translate([-38.35, 10.15+0.4,  34-pm]) rotate([90, 0, 0]) 
  cylinder(r=3.3, h=8, center=true, $fn=6);
 // 60° Lager
 translate([-26.25, 6.4952, 63.5-pm]) rotate([90, 0, 60]) 
  translate([0,0, 9.2]) cylinder(r=3.3, h=6, center=true, $fn=6);
 translate([-26.25,-6.4952, 59.5-pm]) rotate([90, 0,-60]) 
  translate([0,0,-9.2]) cylinder(r=3.3, h=6, center=true, $fn=6);
 //
 translate([-22.5, 10.15, 4.5-pm]) rotate([90, 0, 0]) 
  cylinder(r=3.3, h=8, center=true, $fn=6);
 translate([19.8-0.4,-7.0,  34+pm]) rotate([90, 0, 90]) 
  cylinder(r=3.3, h=8, center=true, $fn=6);
 translate([19.8-0.4,-8.35,  34+pm]) rotate([90, 0, 90]) 
  cylinder(r=3.3, h=8, center=true, $fn=6);
 translate([19.8, 7.5,  63.5+pm]) rotate([90, 0, 90]) 
  cylinder(r=3.3, h=8, center=true, $fn=6);
 translate([21.3, 7.5-dl,  4.5+pm]) rotate([90, 0, 90]) 
  cylinder(r=3.3, h=5, center=true, $fn=6);
 // Gewindestifte zum spannen:
 translate([-45, 4.6+0.5,  34-pm]) rotate([90, 0, 90]) loch60(11, 1.15);
 translate([-45,-4.6-0.5,  34-pm]) rotate([90, 0, 90]) loch60(11, 1.15);
 translate([25.4-0.5,-13.5, 34+pm]) rotate([90, 0, 0]) loch60(9, 1.15);
 translate([34.6+0.5,-13.5,  34+pm]) rotate([90, 0, 0]) loch60(9, 1.15);
 // Lageröffnungen:
 translate([-37.5, 0,  34-pm]) lager(0);
 translate([-22.5, 0, 4.5-pm]) lager(0);
 translate([-26.25, 6.4952,63.5-pm]) rotate([0, 0, 60]) lager(0);
 translate([-26.25,-6.4952,59.5-pm]) rotate([0, 0,-60]) lager(0);
 translate([30, -7.5, 34+pm]) rotate([0, 0, 90]) lager(0); 
 translate([30, 7.5-dl, 4.5+pm]) rotate([0, 0, 90]) lager(0);
 translate([30, 7.5,63.5+pm]) rotate([0, 0, 90]) lager(0);
 // Endschalter-Schraube:
 translate([-15, 16, 9])
  cylinder(r=1.5, h=20, center=true, $fn=12);
 // abschrägen:
 translate([49, 10, 23]){
  rotate([0, 30, 0]) {
   cube([15, 15, 15], center=true);
  }
 }
 translate([-49, 14.7, 23]){
  rotate([0, 60, 0]) {
   cube([15, 15, 15], center=true);
  }
 }
 translate([-60, 0, 51.5-pm]){
  rotate([0, 0, 45]) {
   cylinder(r1=20.5, r2=38, h=34, center=true, $fn=4);
  }
 }
 translate([40,-40, 16.8+pm]){
  rotate([0, 0, 45]) {
   cylinder(r1=45, r2=34.9, h=34.1, center=true, $fn=4);
  }
 }
 translate([33, -30, 51.5+pm]){
  rotate([0, 0, 45]) {
   cylinder(r1=20, r2=50, h=34, center=true, $fn=4);
  }
 }
 // Endschalter-Schraube:
 translate([-41.5, 12.25, 12]){
  rotate([0, 0, 0]) {
   cylinder(r=1.4, h=25, center=true, $fn=12);
  }
 }
 // Gegen Warping:
 translate([33, 0, 13]) cube([15, 3, 20], center=true);
 translate([30, -7, 12]) cube([3, 15, 20], center=true);
 translate([-36, 0, 13]) cube([15, 3, 20], center=true);
 translate([-30, -5, 12]) cube([3, 15, 20], center=true);
 translate([18.37, 3.5, 30]) scale([0.25, 1, 1]) {
  rotate([90, 0, 0]) {  
   rotate([0, 0, 60]) {
    cylinder(r=25, h=12, center=true, $fn=3);
   }
  }
 }
}

% translate([-26.25, 6.4952, 63.5-pm]) rotate([90, 0, 60]) 
  translate([0,0, 7.7]) cylinder(r=3.3, h=3, center=true, $fn=6);

% translate([-26.25,-6.4952, 59.5-pm]) rotate([90, 0,-60]) 
  translate([0,0,-7.7]) cylinder(r=3.3, h=3, center=true, $fn=6);


